//include <stdio.h>
//include <stdlib.h>
//include <math.h>

//  t=0.
double init(double x){
	return -sin(M_PI*x/2.);
}

//   x=a.
double bord(double t){
	return 0.;
}

//w: d(u)/d(t) + d(w)/d(x) = 0
double w(double y){
	return exp(-y*y);
}

//dw: d(u)/d(t) + dw * d(u)/d(x) = 0
double dw(double y){
	return -2. * y * w(y);
}

double func(double y, double prev, double earl, double diag, double *steps){
	const double tau = steps[0];
	const double h = steps[1];
	return y/2./tau + w(y)/2./h + (prev - diag - earl) / 2./tau + (w(earl) - w(diag) - w(prev)) / 2./h;
}

double dunc(double y, double *steps){
	const double tau = steps[0];
	const double h = steps[1];
	return 1./2./tau + dw(y)/2./h;
}

main(){
	double a = 0; //  .
	double b = -1.; //  .
	double T = 1; // .
	int N = 100; //  .
	double tau = .01; // .
	double eps = 1e-6; //    .
	int n_t = (int) T/tau;
	double h = (double) (b-a) / N;
	double steps[] = { tau, h };
	double y[N+1][n_t];
	int i,j;
	double prev, earl, diag, y0;
	
	for (i=0; i<=N; i++)
		y[i][0] = init(a+h*i);
	for (j=0; j<n_t; j++)
		y[0][j] = bord(j*tau);
	
	printf("//x	t	y		h=%lg\n",h);
		
	for (i=1; i<=N; i++){
		for (j=1; j<n_t; j++){
			prev = y[i-1][j];
			earl = y[i][j-1];
			diag = y[i-1][j-1];
			y0 = prev + 2.*eps;
			y[i][j] = prev;
			while ( y0 - y[i][j] > eps | y[i][j] - y0 > eps){
				y0 = y[i][j];
				y[i][j] = y0 - func(y0,prev,earl,diag,steps) / dunc(y0,steps);
			}
			printf("%lg	%lg	%lg\n", a+h*i,j*tau,y[i][j]);
		}
		printf("\n");
	}
	
	return 0;
}

